' DODGY.BAS

' An officially dodgy game. Really it's only supposed to show you how to
' use UDP. The "game" part of it is simply two faces going around the screen.
' It is slightly more advanced than the other examples. I recommend you take
' a look at the others before this one.

REM $INCLUDE: 'wsockqb.bi'

' Game port number is UDP:7892

DIM SHARED NewSocket AS LONG
DIM SHARED Address AS sockaddr
DIM SHARED buffer AS STRING * 2
DIM SHARED OtherAddress AS STRING * 4
DIM SHARED OtherPort AS INTEGER
DIM SHARED MyX AS INTEGER    ' Your X location
DIM SHARED MyY AS INTEGER    ' Your Y location
DIM SHARED OtherX AS INTEGER ' Other computer's X location
DIM SHARED OtherY AS INTEGER ' Other computer's Y location
DIM SHARED MyKills AS INTEGER ' Not used (yet)
DIM SHARED OtherKills AS INTEGER ' Not used (yet)

CLS
PRINT "Initializing WSOCKXS";

ReturnValue% = WSInit
IF ReturnValue% = -4 THEN SHELL "WSLOADER.EXE"
t0! = TIMER
DO UNTIL ReturnValue% <> -4 OR TIMER - t0! > 5 ' Wait maximum 5 seconds
  ReturnValue% = WSInit
LOOP

IF ReturnValue% <> 0 THEN
  PRINT "ERROR: WSInit() error:"; ReturnValue%
  END
ELSE
  PRINT ".";
END IF

DIM SHARED Message AS MessageStruc
EnableMessage

DIM SHARED wsadata AS wsadataStruc
ret& = WSAStartup(&H202, wsadata)
IF ret& <> 0 THEN
  PRINT "ERROR: WSAStartup() error:"; ret&
  GOTO doselfdestruct
END IF
PRINT ".done"
PRINT "Press any key to continue"
SLEEP
CLS

COLOR 15: PRINT "An Extremely DODGIFIED Game v0.5"
PRINT
PRINT "Only 2 players are supported"
PRINT "To join you will need to know the host's IP address"
COLOR 14: PRINT "  Press H to be a host"
PRINT "  Press J to join game"
PRINT "  Press Q to quit"
DO
  a$ = UCASE$(INKEY$)
  IF a$ = "Q" THEN GOTO cleanup
LOOP UNTIL a$ = "H" OR a$ = "J" OR a$ = "B"
IF a$ = "H" THEN
 
  ' Display IP address
  GetMyAddr MyName$, MyIP$
  COLOR 15: PRINT "Your IP address is: " + inetntoa(MyIP$)
  COLOR 2: PRINT "Waiting for client to join..."
 
  ' Create new socket
  NewSocket = socket(AFINET, SOCKDGRAM, IPPROTOUDP)
  IF NewSocket = -1 THEN
    COLOR 4: PRINT "ERROR: socket() error:"; WSAGetLastError
    GOTO cleanup
  END IF
 
  ' Set socket into asynchronous mode
  ReturnValueLong& = WSAAsyncSelect(NewSocket, GetHWnd, &H401, FDREAD)
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: WSAAsyncSelect() error:"; WSAGetLastError
    GOTO cleanup
  END IF
 
  ' Bind socket to port UDP:7892
  Address.sinfamily = AFINET
  Address.sinport = htons(7892) ' This is our port, remember?
  Address.sinaddr = STRING$(4, 0)
  Address.sinzero = STRING$(8, 0)
  ReturnValueLong& = bind(NewSocket, Address, LEN(Address))
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: bind() error:"; WSAGetLastError
    GOTO cleanup
  END IF

  ' Sit in a loop waiting for another player to join. "buffer" must be "CJ"
  ' which means "Client Join". After this send confirmation to the client
  ' with the bytes "CF" for "ConFirm".
keeplistening:
  DO
    IF INKEY$ = CHR$(27) THEN
      COLOR 4: PRINT "ERROR: User aborted"
      GOTO cleanup
    END IF
  LOOP UNTIL GetMessage(Message)
  ReturnValueLong& = recvfrom(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: recvfrom() error:"; WSAGetLastError
    GOTO cleanup
  END IF
  OtherPort = ntohs(Address.sinport)
 
  ' If the two bytes aren't "CJ" then it isn't another player
  IF buffer <> "CJ" THEN GOTO keeplistening  ' CJ = Client Join
 
  ' Send confirmation
  buffer = "CF"                              ' CF = ConFirm
  ReturnValueLong& = sendto(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: sendto() error:"; WSAGetLastError
    GOTO cleanup
  END IF
 
  ' Server handshaking sequence finished
  COLOR 15: PRINT "Client " + inetntoa(Address.sinaddr) + " has joined"
  OtherAddress = Address.sinaddr
  MyX = 3
  MyY = 3
  OtherX = 78
  OtherY = 21

ELSEIF a$ = "J" THEN
 
  ' Create a new socket
  NewSocket = socket(AFINET, SOCKDGRAM, IPPROTOUDP)
  IF NewSocket = -1 THEN
    COLOR 4: PRINT "ERROR: socket() error:"; WSAGetLastError
    GOTO cleanup
  END IF
 
  ' Set the socket into asynchronous mode
  ReturnValueLong& = WSAAsyncSelect(NewSocket, GetHWnd, &H401, FDREAD)
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: WSAAsyncSelect() error:"; WSAGetLastError
    GOTO cleanup
  END IF
 
  ' Get host IP address from user (resolve it if it is a hostname)
  INPUT "Enter hostname or host's IP address"; hostname$
  IF inetaddr(hostname$) <> INADDRNONE THEN
    OtherAddress = inetaddr(hostname$)
  ELSE
    ResolveName hostname$, RealName$, hAlias$, AType%, hLength%, OtherAddress, 0, Errors&
    IF Errors& <> 0 THEN
      COLOR 4: PRINT "ERROR: Hostname " + hostname$ + " does not exist"
      GOTO cleanup
    END IF
  END IF
 
  ' Attempt to join with 2 byte sequence "CJ" for "Client Join"
  COLOR 2
  PRINT "Attempting to join host " + inetntoa(OtherAddress)
  Address.sinfamily = AFINET
  Address.sinport = htons(7892)
  Address.sinaddr = OtherAddress
  Address.sinzero = STRING$(8, 0)
  buffer = "CJ"                              ' CJ = Client Join
  ReturnValueLong& = sendto(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: sendto() error:"; WSAGetLastError
    GOTO cleanup
  END IF
  PRINT "Request sent, waiting for reply..."
 
  t0! = TIMER
keeplistening2:
  DO
    IF TIMER - t0! > 5 THEN ' Wait a maximum of 5 seconds
      COLOR 4: PRINT "ERROR: Host did not reply"
      GOTO cleanup
    END IF
    IF INKEY$ = CHR$(27) THEN
      COLOR 4: PRINT "ERROR: User aborted"
      GOTO cleanup
    END IF
  LOOP UNTIL GetMessage(Message)
  ' Ignore all messages but FDREAD messages
  IF GetLow16(Message.lParam) <> FDREAD THEN GOTO keeplistening2
  ReturnValueLong& = recvfrom(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
  IF ReturnValueLong& = -1 THEN
    COLOR 4: PRINT "ERROR: recvfrom() error:"; WSAGetLastError
    GOTO cleanup
  END IF
  ' Ignore datagrams from ports other than UDP:7892
  IF ntohs(Address.sinport) <> 7892 THEN GOTO keeplistening2
  ' Ignore all datagrams that are not the "ConFirm" sequence
  IF buffer <> "CF" THEN GOTO keeplistening2 ' CF = ConFirm
 
  ' Client handshaking sequence finished
  COLOR 15: PRINT "Reply recieved!"
  OtherX = 3
  OtherY = 3
  MyX = 78
  MyY = 21
  OtherPort = ntohs(Address.sinport)

END IF

CLS
COLOR 14

' Draw borders
FOR b% = 1 TO 80
  LOCATE 1, b%: PRINT CHR$(219)
  LOCATE 23, b%: PRINT CHR$(219)
NEXT b%
FOR b% = 1 TO 23
  LOCATE b%, 1: PRINT CHR$(219)
  LOCATE b%, 80: PRINT CHR$(219)
NEXT b%

' Game loop goes here
' This game sends a packet 5 times a second. It also sends a packet whenever
' you move.
t0! = TIMER
ExitCode = 0
DO
 
  ' All this is just standard text game stuff
  MyMove = 0
  OtherMove = 0
  a$ = INKEY$
  IF a$ = CHR$(27) THEN ExitCode = 1
  IF a$ = CHR$(0) + CHR$(72) THEN
    MyMove = 1
    OldMyX% = MyX
    OldMyY% = MyY
    MyY = MyY - 1
  END IF
  IF a$ = CHR$(0) + CHR$(80) THEN
    MyMove = 1
    OldMyX% = MyX
    OldMyY% = MyY
    MyY = MyY + 1
  END IF
  IF a$ = CHR$(0) + CHR$(75) THEN
    MyMove = 1
    OldMyX% = MyX
    OldMyY% = MyY
    MyX = MyX - 1
  END IF
  IF a$ = CHR$(0) + CHR$(77) THEN
    MyMove = 1
    OldMyX% = MyX
    OldMyY% = MyY
    MyX = MyX + 1
  END IF
  OldOtherX% = OtherX
  OldOtherY% = OtherY
  IF MyX < 2 THEN MyX = 2
  IF MyX > 79 THEN MyX = 79
  IF MyY < 2 THEN MyY = 2
  IF MyY > 22 THEN MyY = 22
 
  ' Have any packets arrived?
  IF GetMessage(Message) THEN
    event% = GetLow16(Message.lParam)
    IF event% <> FDREAD THEN GOTO ignorepacket ' Ignore all other events
   
    ReturnValueLong& = recvfrom(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
    IF ReturnValueLong& = -1 THEN
      LOCATE 1, 1: COLOR 4: PRINT "ERROR: recvfrom() error:"; WSAGetLastError
      ExitCode = 1
    END IF
   
    ' Ignore packets not from the other player
    IF Address.sinaddr <> OtherAddress THEN GOTO ignorepacket
    IF Address.sinport <> htons(OtherPort) THEN GOTO ignorepacket
   
    ' If it is the other player, update the other player's location
    OtherMove = 1
    OtherX = ASC(MID$(buffer, 1, 1))
    OtherY = ASC(MID$(buffer, 2, 1))
   
    ' Special code CHR$(&HFF) + CHR$(&HFF) is "exit code"
    IF buffer = CHR$(&HFF) + CHR$(&HFF) THEN
      CLS
      COLOR 4: LOCATE 1, 1: PRINT "Other user aborted game"
      GOTO cleanup
    END IF

  END IF

ignorepacket:
  IF OldMyX% = MyX AND OldMyY% = MyY THEN MyMove = 0
  IF OldOtherX% = OtherX AND OldOtherY% = OtherY THEN OtherMove = 0
 
  ' If you have moved, send a packet with your location
  IF MyMove = 1 THEN
    Address.sinfamily = AFINET
    Address.sinport = htons(OtherPort)
    Address.sinaddr = OtherAddress
    Address.sinzero = STRING$(8, 0)
    buffer = CHR$(MyX) + CHR$(MyY)
    ReturnValueLong& = sendto(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
    IF ReturnValueLong& = -1 THEN
      LOCATE 1, 1: COLOR 4: PRINT "ERROR: sendto() error:"; WSAGetLastError
      ExitCode = 1
    END IF
  END IF
 
  ' Update player locations
  COLOR 10: LOCATE MyY, MyX: PRINT CHR$(1)
  IF MyMove = 1 THEN LOCATE OldMyY%, OldMyX%: PRINT " "
  COLOR 12: LOCATE OtherY, OtherX: PRINT CHR$(1)
  IF OtherMove = 1 THEN LOCATE OldOtherY%, OldOtherX%: PRINT " "
 
  ' 5 Times every second send a packet with your location - just to be safe
  IF TIMER - t0! >= .2 THEN
    Address.sinfamily = AFINET
    Address.sinport = htons(OtherPort)
    Address.sinaddr = OtherAddress
    Address.sinzero = STRING$(8, 0)
    buffer = CHR$(MyX) + CHR$(MyY)
    ReturnValueLong& = sendto(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
    IF ReturnValueLong& = -1 THEN
      LOCATE 1, 1: COLOR 4: PRINT "ERROR: sendto() error:"; WSAGetLastError
      ExitCode = 1
    END IF
    t0! = TIMER
  END IF
 
  ' If we have to exit tell the other player we are going to exit game
  ' CHR$(&HFF) + CHR$(&HFF) is the special "exit code"
  IF ExitCode = 1 THEN
    Address.sinfamily = AFINET
    Address.sinport = htons(OtherPort)
    Address.sinaddr = OtherAddress
    Address.sinzero = STRING$(8, 0)
    buffer = CHR$(&HFF) + CHR$(&HFF)
    ReturnValueLong& = sendto(NewSocket, buffer, LEN(buffer), 0, Address, LEN(Address))
    IF ReturnValueLong& = -1 THEN
      LOCATE 1, 1: COLOR 4: PRINT "ERROR: sendto() error:"; WSAGetLastError
    END IF
  END IF

LOOP UNTIL ExitCode = 1

CLS
COLOR 4: LOCATE 1, 1: PRINT "You aborted game"

cleanup:

' Closes sockets, cleans up winsock, disables message handling and unloads
' WSOCKXS modules. This program tries to make sure this happens on every
' exit.
junk& = closesocket(NewSocket)
ret& = WSACleanup
DisableMessage

doselfdestruct:
SelfDestruct
COLOR 7

