' MYNAME.BAS

' Simply shows how you can return the local machine's IP address and name.

' Include all WSOCKXS function definitions and constants.
REM $INCLUDE: 'wsockqb.bi'

ReturnValue% = WSInit

' If WSOCKXS.VXD is not loaded, run WSLOADER.EXE
IF ReturnValue% = -4 THEN SHELL "WSLOADER.EXE"
t0! = TIMER
DO UNTIL ReturnValue% <> -4 OR TIMER - t0! > 1  ' Wait maximum one second
  ReturnValue% = WSInit
LOOP

IF ReturnValue% <> 0 THEN
  PRINT "WSInit() ERROR:"; ReturnValue%
  END
END IF

' We don't need message handling, do we.
DisableMessage

' Startup winsock
DIM SHARED wsadata AS wsadataStruc
ret& = WSAStartup(&H202, wsadata)
IF ret& <> 0 THEN
  PRINT "ERROR: WSAStartup() returned:"; ret&
  GOTO endprogram
END IF

' Get local address. Remember myip$ will be a 4-byte string so we need to use
' inetntoa().
GetMyAddr myname$, myip$
PRINT "My name is: "; myname$
PRINT "My IP address is: "; inetntoa(myip$)

' Cleanup winsock
ret& = WSACleanup
IF ret& = -1 THEN
  PRINT "WARNING: WSACleanup() failed:"; WSAGetLastError
END IF

endprogram:

' Close WSLOADER.EXE / unload stuff
SelfDestruct

