' Special functions
DECLARE FUNCTION WSInit%
DECLARE FUNCTION GetHigh16% (BYVAL InLong AS LONG)
DECLARE FUNCTION GetLow16% (BYVAL InLong AS LONG)
DECLARE FUNCTION PTR& ALIAS "STRPTR" (VariableOtherThanString AS ANY)
DECLARE FUNCTION SocketHandle&
DECLARE FUNCTION getshortname% (SEG OutAX AS INTEGER, SEG InString AS STRING, SEG OutString AS STRING)
DECLARE FUNCTION LinMemAlloc&
DECLARE SUB LinMemFree (BYVAL MemoryHandle AS LONG)
DECLARE SUB LinMemCopy (BYVAL LinearSource AS LONG, SEG BufferDest AS STRING)
DECLARE SUB UseLinAsyncBuffer

DECLARE FUNCTION GetHWnd&
DECLARE SUB EnableMessage
DECLARE SUB DisableMessage
DECLARE FUNCTION GetMessage% (SEG InMessageStruc AS ANY)
DECLARE SUB SelfDestruct

DECLARE SUB MoveIntoVariable (DataOFF AS INTEGER, DataSEG AS INTEGER, Pointer AS LONG, length AS INTEGER)
DECLARE FUNCTION PEEK32% (BYVAL LinearAddress AS LONG)
DECLARE FUNCTION SUB32& (BYVAL Operand1 AS LONG, BYVAL Operand2 AS LONG)

' Standard functions
DECLARE FUNCTION accept& (BYVAL hsocket AS LONG, SEG saddrin AS ANY, BYVAL namelen AS LONG)
DECLARE FUNCTION bind& (BYVAL hsocket AS LONG, SEG saddrin AS ANY, BYVAL namelen AS LONG)
DECLARE FUNCTION closesocket& (BYVAL hsocket AS LONG)
DECLARE FUNCTION connect& (BYVAL hsocket AS LONG, SEG saddrin AS ANY, BYVAL namelen AS LONG)
DECLARE FUNCTION getpeername& (BYVAL hsocket AS LONG, SEG saddrin AS ANY, BYVAL namelen AS LONG)
DECLARE FUNCTION getsockname& (BYVAL hsocket AS LONG, SEG saddrin AS ANY, BYVAL namelen AS LONG)
DECLARE FUNCTION getsockopt& (BYVAL hsocket AS LONG, BYVAL level AS LONG, BYVAL optname AS LONG, SEG optval AS ANY, BYVAL optlen AS LONG)
DECLARE FUNCTION htonl& (BYVAL hostlong AS LONG)
DECLARE FUNCTION htons% (BYVAL hostshort AS INTEGER)
DECLARE FUNCTION inetaddr$ (instring AS STRING)
DECLARE FUNCTION inetntoa$ (instring AS STRING)
DECLARE FUNCTION ioctlsocket& (BYVAL hsocket AS LONG, BYVAL cmd AS LONG, SEG param AS ANY)
DECLARE FUNCTION listen& (BYVAL hsocket AS LONG, BYVAL backlog AS LONG)
DECLARE FUNCTION ntohl& (BYVAL netlong AS LONG)
DECLARE FUNCTION ntohs% (BYVAL netshort AS INTEGER)
DECLARE FUNCTION recv& (BYVAL hsocket AS LONG, SEG buffer AS ANY, BYVAL length AS LONG, BYVAL flags AS LONG)
DECLARE FUNCTION recvfrom& (BYVAL hsocket AS LONG, SEG buffer AS ANY, BYVAL length AS LONG, BYVAL flags AS LONG, SEG fromaddr AS ANY, BYVAL fromlen AS LONG)
DECLARE FUNCTION selectsocket& (BYVAL hsocket AS LONG, BYVAL FD AS LONG)
DECLARE FUNCTION send& (BYVAL hsocket AS LONG, SEG buffer AS ANY, BYVAL length AS LONG, BYVAL flags AS LONG)
DECLARE FUNCTION sendto& (BYVAL hsocket AS LONG, SEG buffer AS ANY, BYVAL length AS LONG, BYVAL flags AS LONG, SEG toaddr AS ANY, BYVAL tolen AS LONG)
DECLARE FUNCTION setsockopt& (BYVAL hsocket AS LONG, BYVAL level AS LONG, BYVAL optname AS LONG, SEG optval AS ANY, BYVAL optlen AS LONG)
DECLARE FUNCTION shutdown& (BYVAL hsocket AS LONG, BYVAL how AS LONG)
DECLARE FUNCTION socket& (BYVAL af AS LONG, BYVAL socktype AS LONG, BYVAL protocol AS LONG)

' Database functions
DECLARE FUNCTION gethostbyaddr& (SEG addr AS STRING, BYVAL length AS LONG, BYVAL addrtype AS LONG)
DECLARE FUNCTION gethostbyname& (SEG hostname AS STRING)
DECLARE FUNCTION getprotobyname& (SEG protoname AS STRING)
DECLARE FUNCTION getprotobynumber& (BYVAL number AS LONG)
DECLARE FUNCTION getservbyname& (SEG servname AS STRING, SEG proto AS STRING)
DECLARE FUNCTION getservbyport& (BYVAL port AS LONG, SEG proto AS STRING)
DECLARE FUNCTION gethostname& (SEG hostname AS STRING, BYVAL length AS LONG)
DECLARE SUB ResolveName (hostname AS STRING, RealName AS STRING, HostAlias AS STRING, addrtype AS INTEGER, length AS INTEGER, IPAddr AS STRING, GetMultiple AS INTEGER, ErrorValue AS LONG)
DECLARE SUB GetMyAddr (MyName AS STRING, MyIP AS STRING)

' Extended functions
DECLARE FUNCTION WSAAsyncSelect& (BYVAL hsocket AS LONG, BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, BYVAL iEvent AS LONG)
DECLARE FUNCTION WSAAsyncGetHostByAddr& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG addr AS STRING, BYVAL length AS LONG, BYVAL addrtype AS LONG, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSAAsyncGetHostByName& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG hostname AS STRING, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSAAsyncGetProtoByNumber& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, BYVAL number AS LONG, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSAAsyncGetProtoByName& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG protoname AS STRING, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSAAsyncGetServByPort& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, BYVAL port AS LONG, SEG proto AS STRING, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSAAsyncGetServByName& (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG servname AS STRING, SEG proto AS STRING, SEG buffer AS ANY, BYVAL bufferlength AS LONG)
DECLARE FUNCTION WSACancelAsyncRequest& (BYVAL asynctaskhandle AS LONG)
DECLARE FUNCTION WSAGetLastError&
DECLARE FUNCTION WSAStartup& (BYVAL VersionRequested AS LONG, SEG wsadatabuffer AS ANY)
DECLARE FUNCTION WSACleanup&
DECLARE SUB AsyncResolveName (SEG hostname AS STRING, BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG AsyncHandle AS LONG, SEG MemoryHandle AS LONG, SEG ErrorValue AS LONG)
DECLARE SUB AsyncResolveAddr (SEG addr AS STRING, BYVAL length AS LONG, BYVAL addrtype AS LONG, BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, SEG AsyncHandle AS LONG, SEG MemoryHandle AS LONG, SEG ErrorValue AS LONG)
DECLARE SUB CancelResolve (BYVAL AsyncHandle AS LONG, BYVAL MemoryHandle AS LONG)
DECLARE SUB ProcessResolve (MemoryHandle AS LONG, RealName AS STRING, HostAlias AS STRING, addrtype AS INTEGER, length AS INTEGER, IPAddr AS STRING, GetMultiple AS INTEGER)

' Timer functions
DECLARE SUB StartTimer
DECLARE SUB StopTimer
DECLARE FUNCTION GetTimer&
DECLARE SUB ResetTimer

' Commonly used TYPE structures
TYPE sockaddr
  sinfamily AS INTEGER
  sinport AS INTEGER
  sinaddr AS STRING * 4
  sinzero AS STRING * 8
END TYPE
TYPE wsadataStruc
  wVersion AS INTEGER
  wHighVersion AS INTEGER
  szDescription AS STRING * 257
  szSystemStatus AS STRING * 129
  iMaxSockets AS INTEGER
  iMaxUdpDg AS INTEGER
  lpVendorInfo AS STRING * 200
END TYPE
TYPE MessageStruc
  hwnd AS LONG
  uMsg AS LONG
  wParam AS LONG
  lParam AS LONG
END TYPE

' IOCTL controls
CONST FIONREAD = &H4004667F
CONST FIONBIO = &H8004667E
CONST SIOCATMARK = &H40047307

' Protocols
CONST IPPROTOIP = 0
CONST IPPROTOICMP = 1
CONST IPPROTOGGP = 2
CONST IPPROTOTCP = 6
CONST IPPROTOPUP = 12
CONST IPPROTOUDP = 17
CONST IPPROTOIDP = 22
CONST IPPROTOND = 77
CONST IPPROTORAW = 255
CONST IPPROTOMAX = 256

' Port numbers for standard functions
CONST IPPORTECHO = 7
CONST IPPORTDISCARD = 9
CONST IPPORTSYSTAT = 11
CONST IPPORTDAYTIME = 13
CONST IPPORTNETSTAT = 15
CONST IPPORTFTP = 21
CONST IPPORTTELNET = 23
CONST IPPORTSMTP = 25
CONST IPPORTTIMESERVER = 37
CONST IPPORTNAMESERVER = 42
CONST IPPORTWHOIS = 43
CONST IPPORTMPT = 57
CONST IPPORTTFTP = 69
CONST IPPORTRJE = 77
CONST IPPORTFINGER = 79
CONST IPPORTTTYLINK = 87
CONST IPPORTSUPDUP = 95
' Unix ports
CONST IPPORTEXECSERVER = 512
CONST IPPORTLOGINSERVER = 513
CONST IPPORTCMDSERVER = 514
CONST IPPORTEFSSERVER = 520
CONST IPPORTBIFFUDP = 512
CONST IPPORTWHOSERVER = 513
CONST IPPORTROUTESERVER = 520
' Any ports below IPPORTRESERVED are officially declared
' for something
CONST IPPORTRESERVED = 1024

' Address definitions - being strings they cannot
' use CONST since CHR$ cannot be used to declare
' CONSTants
DIM SHARED INADDRANY AS STRING * 4
DIM SHARED INADDRLOOPBACK AS STRING * 4
DIM SHARED INADDRBROADCAST AS STRING * 4
DIM SHARED INADDRNONE AS STRING * 4

INADDRANY = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)              ' 0.0.0.0
INADDRLOOPBACK = CHR$(127) + CHR$(0) + CHR$(0) + CHR$(1)       ' 127.0.0.1
INADDRBROADCAST = CHR$(255) + CHR$(255) + CHR$(255) + CHR$(255)' 255.255.255.255
INADDRNONE = CHR$(255) + CHR$(255) + CHR$(255) + CHR$(255)     ' 255.255.255.255

' Used for IP level options with get/setsocketopt
CONST IPOPTIONS = 1

' Any operation will return SOCKETERROR if some error happened
CONST SOCKETERROR = -1

' Socket types
CONST SOCKSTREAM = 1
CONST SOCKDGRAM = 2
CONST SOCKRAW = 3
CONST SOCKRDM = 4
CONST SOCKSEQPACKET = 5

' Option flags
CONST SODEBUG = &H1
CONST SOACCEPTCONN = &H2
CONST SOREUSEADDR = &H4
CONST SOKEEPALIVE = &H8
CONST SODONTROUTE = &H10
CONST SOBROADCAST = &H20
CONST SOUSELOOPBACK = &H40
CONST SOLINGER = &H80
CONST SOOOBINLINE = &H100
CONST SODONTLINGER = &HFFFFFF7F
CONST SOSNDBUF = &H1001
CONST SORCVBUF = &H1002
CONST SOSNDLOWAT = &H1003
CONST SORCVLOWAT = &H1004
CONST SOSNDTIMEO = &H1005
CONST SORCVTIMEO = &H1006
CONST SOERROR = &H1007
CONST SOTYPE = &H1008
CONST SOGROUPID = &H2001
CONST SOGROUPPRIORITY = &H2002
CONST SOMAXMSGSIZE = &H2003
CONST SOPROTOCOLINFO = &H2004
CONST PVDCONFIG = &H3001
CONST TCPNODELAY = &H1

' Ways to shutdown
CONST SDRECIEVE = 0
CONST SDSEND = 1
CONST SDBOTH = 2

' Address families
CONST AFUNSPEC = 0
CONST AFUNIX = 1
CONST AFINET = 2
CONST AFIMPLINK = 3
CONST AFPUP = 4
CONST AFCHAOS = 5
CONST AFNS = 6
CONST AFISO = 7
CONST AFOSI = 7
CONST AFECMA = 8
CONST AFDATAKIT = 9
CONST AFCCITT = 10
CONST AFSNA = 11
CONST AFDECnet = 12
CONST AFDLI = 13
CONST AFLAT = 14
CONST AFHYLINK = 15
CONST AFAPPLETALK = 16
CONST AFNETBIOS = 17
CONST AFMAX = 18

' Used for socket level options with get/setsocketopt
CONST SOLSOCKET = &HFFFF

' Maximum (???) queue length for BackLog in listen
CONST SOMAXCONN = 5

' Send/recv flags
CONST MSGOOB = 1
CONST MSGPEEK = 2
CONST MSGDONTROUTE = 4
CONST MSGMAXIOVLEN = 16

' Maximum size of structure returned by gethostbyname and
' gethostbyaddr (and their respective asynchronous functions).
' As specified in rfc883

CONST MAXGETHOSTSTRUCT = 1024

' Flags for use with WSAAsyncSelect
CONST FDREAD = &H1
CONST FDWRITE = &H2
CONST FDOOB = &H4
CONST FDACCEPT = &H8
CONST FDCONNECT = &H10
CONST FDCLOSE = &H20
CONST FDQOS = &H40
CONST FDGROUPQOS = &H80

' Special connect failure for selectsocket (???)
CONST FDFAILEDCONNECT = &H100

' Errors returned by winsock functions
CONST WSAEINTR = 10004
CONST WSAEBADF = 10009
CONST WSAEACCES = 10013
CONST WSAEFAULT = 10014
CONST WSAEINVAL = 10022
CONST WSAEMFILE = 10024
CONST WSAEWOULDBLOCK = 10035
CONST WSAEINPROGRESS = 10036
CONST WSAEALREADY = 10037
CONST WSAENOTSOCK = 10038
CONST WSAEDESTADDRREQ = 10039
CONST WSAEMSGSIZE = 10040
CONST WSAEPROTOTYPE = 10041
CONST WSAENOPROTOOPT = 10042
CONST WSAEPROTONOSUPPORT = 10043
CONST WSAESOCKTNOSUPPORT = 10044
CONST WSAEOPNOTSUPP = 10045
CONST WSAEPFNOSUPPORT = 10046
CONST WSAEAFNOSUPPORT = 10047
CONST WSAEADDRINUSE = 10048
CONST WSAEADDRNOTAVAIL = 10049
CONST WSAENETDOWN = 10050
CONST WSAENETUNREACH = 10051
CONST WSAENETRESET = 10052
CONST WSAECONNABORTED = 10053
CONST WSAECONNRESET = 10054
CONST WSAENOBUFS = 10055
CONST WSAEISCONN = 10056
CONST WSAENOTCONN = 10057
CONST WSAESHUTDOWN = 10058
CONST WSAETOOMANYREFS = 10059
CONST WSAETIMEDOUT = 10060
CONST WSAECONNREFUSED = 10061
CONST WSAELOOP = 10062
CONST WSAENAMETOOLONG = 10063
CONST WSAEHOSTDOWN = 10064
CONST WSAEHOSTUNREACH = 10065
CONST WSAENOTEMPTY = 10066
CONST WSAEPROCLIM = 10067
CONST WSAEUSERS = 10068
CONST WSAEDQUOT = 10069
CONST WSAESTALE = 10070
CONST WSAEREMOTE = 10071
CONST WSASYSNOTREADY = 10091
CONST WSAVERNOTSUPPORTED = 10092
CONST WSANOTINITIALISED = 10093
CONST WSAHOSTNOTFOUND = 11001
CONST WSATRYAGAIN = 11002
CONST WSANORECOVERY = 11003
CONST WSANODATA = 11004
CONST WSANOADDRESS = 11004


